
include:
  - template: Security/Dependency-Scanning.gitlab-ci.yml
  - template: Security/SAST.gitlab-ci.yml
  - template: Security/Secret-Detection.gitlab-ci.yml
  # - template: Security/Container-Scanning.gitlab-ci.yml

workflow:
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
    - if: $CI_COMMIT_REF_PROTECTED

default:
  image: node:18-alpine
  before_script:
    - |
      {
        echo "@${CI_PROJECT_ROOT_NAMESPACE}:registry=${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/npm/"
        echo "${CI_API_V4_URL#https?}/projects/${CI_PROJECT_ID}/packages/npm/:_authToken=\${CI_JOB_TOKEN}"
      } | tee -a .npmrc
    - |
      if [[ "$CI_JOB_NAME" != "nodejs-scan-sast" && "$CI_JOB_NAME" != "semgrep-sast" && "$CI_JOB_NAME" != "eslint-sast" && "$CI_JOB_NAME" != "gemnasium-dependency_scanning" && "$CI_JOB_NAME" != "secret_detection" ]]; then
        npm ci --cache .npm --prefer-offline --ignore-scripts
      fi
  cache: # Cache modules using lock file
    key:
      files:
        - package-lock.json
    paths:
      - .npm/

stages:
  - '🕵️ lint'
  - '📦 builds'
  - '🧪 tests'
  - '🦄 quality'

'📝 format':
  stage: '🕵️ lint'
  dependencies: []
  script:
    - npm run format

'🚧 build':
  stage: '📦 builds'
  script:
    - npm run build
  dependencies: []
  artifacts:
    paths:
      - dist/

'✔ unit tests':
  stage: '🧪 tests'
  script:
    - npm run test:unit
  dependencies: []
  coverage: /All files[^|]*\|[^|]*\s+([\d\.]+)/
  artifacts:
    paths:
      - coverage/
    when: always
    reports:
      junit:
        - junit.xml
      coverage_report:
        coverage_format: cobertura
        path: coverage/cobertura-coverage.xml

'🔌 integration tests':
  stage: '🧪 tests'
  dependencies: []
  script:
    - npm run test:int

sast:
  stage: '🦄 quality'
  variables:
  dependencies:
    - '🚧 build'

dependency_scanning:
  stage: '🦄 quality'
  dependencies:
    - '🚧 build'

secret_detection:
  stage: '🦄 quality'
  dependencies:
    - '🚧 build'
